<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="用户ID" prop="userId">
        <el-input v-model="formData.userId" placeholder="请输入用户ID" />
      </el-form-item>
      <el-form-item label="提现渠道类型" prop="withdrawalType">
        <el-select v-model="formData.withdrawalType" placeholder="请选择提现渠道类型">
          <el-option label="请选择字典生成" value="" />
        </el-select>
      </el-form-item>
      <el-form-item label="提现金额,单位:元" prop="amount">
        <el-input v-model="formData.amount" placeholder="请输入提现金额,单位:元" />
      </el-form-item>
      <el-form-item label="支付宝账号" prop="withdrawalAccount">
        <el-input v-model="formData.withdrawalAccount" placeholder="请输入支付宝账号" />
      </el-form-item>
      <el-form-item label="提现状态,已完成是1，未完成为0" prop="status">
        <el-radio-group v-model="formData.status">
          <el-radio label="1">请选择字典生成</el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="提现渠道记录id" prop="applicationForWithdrawalChannelId">
        <el-input v-model="formData.applicationForWithdrawalChannelId" placeholder="请输入提现渠道记录id" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { ApplicationForWithdrawalApi, ApplicationForWithdrawalVO } from '@/api/system/distri/withdrawal'

/** 提现申请记录 表单 */
defineOptions({ name: 'ApplicationForWithdrawalForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  userId: undefined,
  withdrawalType: undefined,
  amount: undefined,
  withdrawalAccount: undefined,
  status: undefined,
  applicationForWithdrawalChannelId: undefined
})
const formRules = reactive({
  userId: [{ required: true, message: '用户ID不能为空', trigger: 'blur' }],
  withdrawalType: [{ required: true, message: '提现渠道类型不能为空', trigger: 'change' }],
  amount: [{ required: true, message: '提现金额,单位:元不能为空', trigger: 'blur' }],
  withdrawalAccount: [{ required: true, message: '支付宝账号不能为空', trigger: 'blur' }],
  applicationForWithdrawalChannelId: [{ required: true, message: '提现渠道记录id不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await ApplicationForWithdrawalApi.getApplicationForWithdrawal(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as ApplicationForWithdrawalApi.ApplicationForWithdrawalVO
    if (formType.value === 'create') {
      await ApplicationForWithdrawalApi.createApplicationForWithdrawal(data)
      message.success(t('common.createSuccess'))
    } else {
      await ApplicationForWithdrawalApi.updateApplicationForWithdrawal(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    userId: undefined,
    withdrawalType: undefined,
    amount: undefined,
    withdrawalAccount: undefined,
    status: undefined,
    applicationForWithdrawalChannelId: undefined
  }
  formRef.value?.resetFields()
}
</script>